Index: uspace/drv/ohci/batch.c
===================================================================
--- uspace/drv/ohci/batch.c	(revision aa9ccf72e4d3364dd14dd7f3705614afea848a26)
+++ uspace/drv/ohci/batch.c	(revision d017cea07b4e7cb0a582e6b399e54debc2523481)
@@ -73,9 +73,6 @@
 	CHECK_NULL_DISPOSE_RETURN(instance,
 	    "Failed to allocate batch instance.\n");
-	usb_target_t target =
-	    { .address = ep->address, .endpoint = ep->endpoint };
-	usb_transfer_batch_init(instance, target, ep->transfer_type, ep->speed,
-	    ep->max_packet_size, buffer, NULL, buffer_size, NULL, setup_size,
-	    func_in, func_out, arg, fun, ep, NULL);
+	usb_transfer_batch_init(instance, ep, buffer, NULL, buffer_size,
+	    NULL, setup_size, func_in, func_out, arg, fun, NULL);
 
 	ohci_batch_t *data = malloc(sizeof(ohci_batch_t));
@@ -101,6 +98,6 @@
 
         if (buffer_size > 0) {
-                instance->transport_buffer = malloc32(buffer_size);
-                CHECK_NULL_DISPOSE_RETURN(instance->transport_buffer,
+                instance->data_buffer = malloc32(buffer_size);
+                CHECK_NULL_DISPOSE_RETURN(instance->data_buffer,
                     "Failed to allocate device accessible buffer.\n");
         }
@@ -124,5 +121,5 @@
 	free32(data->tds);
 	free32(instance->setup_buffer);
-	free32(instance->transport_buffer);
+	free32(instance->data_buffer);
 	free(data);
 	free(instance);
@@ -165,6 +162,5 @@
 	assert(instance);
 	/* We are data out, we are supposed to provide data */
-	memcpy(instance->transport_buffer, instance->buffer,
-	    instance->buffer_size);
+	memcpy(instance->data_buffer, instance->buffer, instance->buffer_size);
 	instance->next_step = batch_call_out_and_dispose;
 	batch_control(instance, USB_DIRECTION_OUT, USB_DIRECTION_IN);
@@ -183,5 +179,4 @@
 {
 	assert(instance);
-	assert(instance->direction == USB_DIRECTION_IN);
 	instance->next_step = batch_call_in_and_dispose;
 	batch_data(instance);
@@ -192,8 +187,6 @@
 {
 	assert(instance);
-	assert(instance->direction == USB_DIRECTION_OUT);
 	/* We are data out, we are supposed to provide data */
-	memcpy(instance->transport_buffer, instance->buffer,
-	    instance->buffer_size);
+	memcpy(instance->data_buffer, instance->buffer, instance->buffer_size);
 	instance->next_step = batch_call_out_and_dispose;
 	batch_data(instance);
@@ -204,5 +197,4 @@
 {
 	assert(instance);
-	instance->direction = USB_DIRECTION_IN;
 	instance->next_step = batch_call_in_and_dispose;
 	batch_data(instance);
@@ -213,5 +205,4 @@
 {
 	assert(instance);
-	instance->direction = USB_DIRECTION_IN;
 	instance->next_step = batch_call_in_and_dispose;
 	batch_data(instance);
@@ -249,5 +240,5 @@
 	size_t td_current = 1;
 	size_t remain_size = instance->buffer_size;
-	char *transfer_buffer = instance->transport_buffer;
+	char *buffer = instance->data_buffer;
 	while (remain_size > 0) {
 		size_t transfer_size = remain_size > OHCI_TD_MAX_TRANSFER ?
@@ -255,5 +246,5 @@
 		toggle = 1 - toggle;
 
-		td_init(&data->tds[td_current], data_dir, transfer_buffer,
+		td_init(&data->tds[td_current], data_dir, buffer,
 		    transfer_size, toggle);
 		td_set_next(&data->tds[td_current], &data->tds[td_current + 1]);
@@ -262,5 +253,5 @@
 		    data->tds[td_current].next, data->tds[td_current].be);
 
-		transfer_buffer += transfer_size;
+		buffer += transfer_size;
 		remain_size -= transfer_size;
 		assert(td_current < data->td_count - 2);
@@ -290,5 +281,5 @@
 	size_t td_current = 0;
 	size_t remain_size = instance->buffer_size;
-	char *transfer_buffer = instance->transport_buffer;
+	char *buffer = instance->data_buffer;
 	while (remain_size > 0) {
 		size_t transfer_size = remain_size > OHCI_TD_MAX_TRANSFER ?
@@ -296,5 +287,5 @@
 
 		td_init(&data->tds[td_current], instance->ep->direction,
-		    transfer_buffer, transfer_size, -1);
+		    buffer, transfer_size, -1);
 		td_set_next(&data->tds[td_current], &data->tds[td_current + 1]);
 		usb_log_debug("Created DATA TD: %x:%x:%x:%x.\n",
@@ -302,5 +293,5 @@
 		    data->tds[td_current].next, data->tds[td_current].be);
 
-		transfer_buffer += transfer_size;
+		buffer += transfer_size;
 		remain_size -= transfer_size;
 		assert(td_current < data->td_count);
